<html>
  <head>
    <title>Nonogramme Vue.js</title>
    <style>
      table {
        border: 1px solid gray;
        border-collapse: collapse;
      }
      tr, td {
        height: 20px;
      }
      td {
        width: 20px;
        border: 1px solid gray;
      }
      td:hover {
        background-color: red;
      }
      .selected {
        background-color: blue;
      }
    </style>
  </head>
  <body>
    <div id='n7-nonogramme-vuejs'>

      <div>
        Configuration du Nonogramme
        <br/>

        <label>Nombre de colonnes</label>
        <input v-model.number="numberCells" type="number" />
        
        <label>Nombre de lignes</label>
        <input v-model.number="numberRows" type="number" />
        
        <button @click="createCellsValuesArray">Créer le nonogramme</button>
      </div>
      
      <table>
        <tr
          v-for="(currentRow, rowIndex) in cellsValues"
          :key="'r' + rowIndex"
        >
          <td
            v-for="(isCurrentCellSelected, cellIndex) in currentRow"
            :key="'r' + rowIndex + 'c' + cellIndex"
            :class="isCurrentCellSelected ? 'selected' : ''"
            @click="$set(currentRow, cellIndex, !currentRow[cellIndex])"
          />
        </tr>
      </table>

      <div>
        <label>Titre</label>
        <input v-model="title" type="text" />
        <br/>

        <button @click="exportPicross">
          Exporter le nonogramme
        </button>
        <pre
          style="border: 1px solid gray; height: 10rem;overflow: auto;"
        >{{ picrossExported }}</pre>
      </div>
    </div>
    <script src="https://unpkg.com/vue"></script>
    <script type="text/javascript">
      const app = new Vue({
        data: {
          title: '',
          numberRows: 6,
          numberCells: 6,
          cellsValues: null,
          picrossExported: null
        },
        computed: {
          picrossData () {
            // parcours du tableau
            // création d'un objet mémoire recensant les cellules activées
            // on stocke à la fois par colonnes et par lignes
            const rowsData = []
            const columnsCellsData = []
            /**
             * Première étape,
             * on recense chaque cellule 
             * dans deux tableaux distincts,
             * * l'un pour les lignes,
             * * l'autre pour les colonnes
             */
            this.cellsValues.forEach(cells => {
              const rowData = []
              let previousNumberCellsEnabled = 0
              cells.forEach((currentCellStatus, indexTableColumn) => {
                if (currentCellStatus === true) {
                  previousNumberCellsEnabled++
                } else if (previousNumberCellsEnabled > 0) {
                  rowData.push(previousNumberCellsEnabled)
                  previousNumberCellsEnabled = 0
                }
                if (columnsCellsData.length === indexTableColumn) {
                  columnsCellsData.push([])
                }
                columnsCellsData[indexTableColumn].push(currentCellStatus)
              })
              if (previousNumberCellsEnabled > 0) {
                rowData.push(previousNumberCellsEnabled)
              }
              rowsData.push(rowData)
            })

            /**
             * Deuxième étape,
             * on calcule les enchaînements des colonnes
             */
            const columnsData = columnsCellsData.map(currentColumnCellData => {
              const columnData = []
              let previousNumberCellsEnabled = 0
              currentColumnCellData.forEach(currentCell => {
                if (currentCell) {
                  previousNumberCellsEnabled++
                } else if (previousNumberCellsEnabled > 0) {
                  columnData.push(previousNumberCellsEnabled)
                  previousNumberCellsEnabled = 0
                }
              })
              if (previousNumberCellsEnabled > 0) {
                columnData.push(previousNumberCellsEnabled)
              }
              return columnData
            })

            return {
              data: {
                rows: rowsData,
                columns: columnsData
              },
              size: {
                rows: rowsData.length,
                columns: columnsData.length
              }
            }
          }
        },
        methods: {
          createCellsValuesArray() {
            const cellsValues = []
            for (let i = 0; i < this.numberRows; i++) {
              const currentRowCellsValues = new Array(this.numberCells).fill(false, 0, this.numberCells)
              cellsValues.push(currentRowCellsValues)
            }
            this.cellsValues = cellsValues
          },
          exportPicross() {
            this.picrossExported = {
              title: this.title,
              ...this.picrossData
            }
          }
        },
        created () {
          this.numberCells = 10
          this.createCellsValuesArray()
        }
      }).$mount('#n7-nonogramme-vuejs')
    </script>
  </body>
</html>
